define(['promptTypes', 'jquery', 'underscore', 'prompts', 'opendatakit', 'database'],
    function(promptTypes, $, _, prompts, opendatakit, database) {
        return {
          'custom_linked_table': promptTypes.linked_table.extend({
            type: 'custom_linked_table',
            buttonLabel: {
              'default': 'Send an SMS'
            },
            // The bulk of this function was taken from a launch_intent prompt
            // in prompts.js. This is only needed if you need to access data
            // collected in the same form when sending an SMS. All the
            // statements except those beginning with that.intentParameters
            // need to remain in order to preserve normal functionality.
        configureRenderContext: function(ctxt) {
        var that = this;
        var queryDefn = opendatakit.getQueriesDefinition(this.values_list);
        ctxt.log('D',"prompts." + that.type + ".configureRenderContext", "px: " + that.promptIdx);
        that.renderContext.max_size = that.display.max_size;
        that.renderContext.custom_hide_add_instance = false;
        that.renderContext.new_instance_text = ((that.display.new_instance_text != null) ? that.display.new_instance_text : "New");
        that.getlinkedModel($.extend({},ctxt,{success:function(linkedModel) {
            var dbTableName = linkedModel.table_id;
            var selString = that.convertSelection(linkedModel);
            var selArgs = queryDefn.selectionArgs();
            var ordBy = that.convertOrderBy(linkedModel);
            var displayElementName = that.getLinkedInstanceName();
            ctxt.log('D',"prompts." + that.type + ".configureRenderContext.before.get_linked_instances", "px: " + that.promptIdx);
            database.get_linked_instances($.extend({},ctxt,{success:function(instanceList) {
                ctxt.log('D',"prompts." + that.type + ".configureRenderContext.success.get_linked_instances", "px: " + that.promptIdx);
                var filteredInstanceList = _.filter(instanceList, function(instance) {
                    return that.choice_filter(instance);
                });
                instanceList = filteredInstanceList;
                // set the image icon
                for (var i = 0; i < instanceList.length ; i++){
                    // sets the savepoint_type to incomplete if the formId doesn't match the current form
                    if (instanceList[i]["form_id"] != that.getLinkedFormId()) {
                        instanceList[i].savepoint_type = opendatakit.savepoint_type_incomplete;
                    }
                    
                    if (instanceList[i]["savepoint_type"] == "COMPLETE"){
                        instanceList[i]["icon_class"] = "ui-icon-check";
                    }  
                    else{
                        instanceList[i]["icon_class"] = "ui-icon-alert";
                    }
                    //make the date more readable
                    instanceList[i]["savepoint_timestamp"] = opendatakit.getShortDateFormat(instanceList[i]["savepoint_timestamp"]);          
                }

                that.renderContext.instances = instanceList;

                // Check here if the instance list should be limited
                if (that.renderContext.instances.length < that.renderContext.max_size()) {
                    that.renderContext.custom_hide_add_instance = false;
                } else {
                    that.renderContext.custom_hide_add_instance = true;
                }

                that.renderContext.columns = [
                    { title : "Last Saved"},
                    { title : "Name"},
                    { title : "Finalized"},
                    { title : ""}
                ];
                    
             
                ctxt.log('D',"prompts." + that.type + ".configureRenderContext.success.get_linked_instances.success", "px: " + that.promptIdx + " instanceList: " + instanceList.length+ " that.display.max_size: " + that.display.max_size);
                ctxt.success();
            }}), dbTableName, selString, selArgs, displayElementName, ordBy);
        }}));
    },
            intentString: 'org.opendatakit.smsbridge.activity.SMSDispatcherActivity',
            intentParameters: {
              extras: {
                require_confirmation: true,
                message_body: 'Default message body',
              }
            }
          })
        };
      });